std::basic_ifstream(3)

NAME
std::basic_ifstream -

SYNOPSIS

Inherits basic_istream< _CharT, _Traits >.

Detailed Description

  template<typename _CharT, typename _Traits> class std::basic_ifstream< _CharT, _Traits >
This class supports reading from named files, using the inherited functions from std::basic_istream. To control the associated sequence, an instance of std::basic_filebuf is used, which this page refers to as sb.

Definition at line 403 of file fstream.

  Public Types
typedef ctype< _CharT > __ctype_type
typedef basic_filebuf< char_type, traits_type > __filebuf_type
typedef basic_ios< _CharT, _Traits > __ios_type
typedef basic_istream< char_type, traits_type > __istream_type
typedef num_get< _CharT, istreambuf_iterator< _CharT, _Traits > > __num_get_type
typedef basic_streambuf< _CharT, _Traits > __streambuf_type
typedef _CharT char_type
copyfmt_event
erase_event
enum event { erase_event, imbue_event, copyfmt_event }
typedef void(*) event_callback (event, ios_base &, int)
typedef _Ios_Fmtflags fmtflags
imbue_event
typedef traits_type::int_type int_type
typedef int io_state
typedef _Ios_Iostate iostate
typedef traits_type::off_type off_type
typedef int open_mode
typedef _Ios_Openmode openmode
typedef traits_type::pos_type pos_type
typedef int seek_dir
typedef _Ios_Seekdir seekdir
typedef std::streamoff streamoff
typedef std::streampos streampos
typedef _Traits traits_type

typedef num_put< _CharT, ostreambuf_iterator< _CharT, _Traits > > __num_put_type

  Public Member Functions
const locale & _M_getloc () const
void _M_setstate (iostate __state)
bool bad () const
basic_ifstream (const char *__s, ios_base::openmode __mode=ios_base::in)
basic_ifstream ()
void clear (iostate __state=goodbit)
void close ()
basic_ios & copyfmt (const basic_ios &__rhs)
bool eof () const
void exceptions (iostate __except)
iostate exceptions () const
bool fail () const
char_type fill (char_type __ch)
char_type fill () const
fmtflags flags (fmtflags __fmtfl)
fmtflags flags () const
streamsize gcount () const
template<> basic_istream< wchar_t > & getline (char_type *__s, streamsize __n, char_type __delim)
template<> basic_istream< char > & getline (char_type *__s, streamsize __n, char_type __delim)
locale getloc () const
bool good () const
template<> basic_istream< wchar_t > & ignore (streamsize __n, int_type __delim)
template<> basic_istream< wchar_t > & ignore (streamsize __n)
template<> basic_istream< char > & ignore (streamsize __n, int_type __delim)
template<> basic_istream< char > & ignore (streamsize __n)
locale imbue (const locale &__loc)
bool is_open () const
bool is_open ()
long & iword (int __ix)
char narrow (char_type __c, char __dfault) const
void open (const char *__s, ios_base::openmode __mode=ios_base::in)
streamsize precision (streamsize __prec)
streamsize precision () const
void *& pword (int __ix)
basic_streambuf< _CharT, _Traits > * rdbuf (basic_streambuf< _CharT, _Traits > *__sb)
__filebuf_type * rdbuf () const
iostate rdstate () const
void register_callback (event_callback __fn, int __index)
fmtflags setf (fmtflags __fmtfl, fmtflags __mask)
fmtflags setf (fmtflags __fmtfl)
void setstate (iostate __state)
basic_ostream< _CharT, _Traits > * tie (basic_ostream< _CharT, _Traits > *__tiestr)
basic_ostream< _CharT, _Traits > * tie () const
void unsetf (fmtflags __mask)
char_type widen (char __c) const
streamsize width (streamsize __wide)
streamsize width () const
~basic_ifstream ()

Unformatted Input Functions
All the unformatted input functions have some common behavior. Each starts by constructing a temporary object of type std::basic_istream::sentry with the second argument (noskipws) set to true. This has several effects, concluding with the setting of a status flag; see the sentry documentation for more.

If the sentry status is good, the function tries to extract whatever data is appropriate for the type of the argument.

The number of characters extracted is stored for later retrieval by gcount().

If an exception is thrown during extraction, ios_base::badbit will be turned on in the stream's error state without causing an ios_base::failure to be thrown. The original exception will then be rethrown.

__istream_type & get (__streambuf_type &__sb)
__istream_type & get (__streambuf_type &__sb, char_type __delim)
__istream_type & get (char_type *__s, streamsize __n)
__istream_type & get (char_type *__s, streamsize __n, char_type __delim)
__istream_type & get (char_type &__c)
int_type get ()
__istream_type & getline (char_type *__s, streamsize __n)
__istream_type & getline (char_type *__s, streamsize __n, char_type __delim)
__istream_type & ignore (streamsize __n, int_type __delim)
__istream_type & ignore (streamsize __n)
__istream_type & ignore ()
int_type peek ()
__istream_type & putback (char_type __c)
__istream_type & read (char_type *__s, streamsize __n)
streamsize readsome (char_type *__s, streamsize __n)
__istream_type & seekg (off_type, ios_base::seekdir)
__istream_type & seekg (pos_type)
int sync ()
pos_type tellg ()
__istream_type & unget ()

operator void * () const
bool operator! () const

Arithmetic Extractors
All the operator>> functions (aka formatted input functions) have some common behavior. Each starts by constructing a temporary object of type std::basic_istream::sentry with the second argument (noskipws) set to false. This has several effects, concluding with the setting of a status flag; see the sentry documentation for more.

If the sentry status is good, the function tries to extract whatever data is appropriate for the type of the argument.

If an exception is thrown during extraction, ios_base::badbit will be turned on in the stream's error state without causing an ios_base::failure to be thrown. The original exception will then be rethrown.

__istream_type & operator>> (__streambuf_type *__sb)
__istream_type & operator>> (void *&__p)
__istream_type & operator>> (long double &__f)
__istream_type & operator>> (double &__f)
__istream_type & operator>> (float &__f)
__istream_type & operator>> (unsigned long long &__n)
__istream_type & operator>> (long long &__n)
__istream_type & operator>> (unsigned long &__n)
__istream_type & operator>> (long &__n)
__istream_type & operator>> (unsigned int &__n)
__istream_type & operator>> (int &__n)
__istream_type & operator>> (unsigned short &__n)
__istream_type & operator>> (short &__n)
__istream_type & operator>> (bool &__n)

__istream_type & operator>> (ios_base &(*__pf)(ios_base &))
__istream_type & operator>> (__ios_type &(*__pf)(__ios_type &))
__istream_type & operator>> (__istream_type &(*__pf)(__istream_type &))

  Static Public Member Functions
static bool sync_with_stdio (bool __sync=true)
static int xalloc () throw ()

  Static Public Attributes
static const fmtflags adjustfield
static const openmode app
static const openmode ate
static const iostate badbit
static const fmtflags basefield
static const seekdir beg
static const openmode binary
static const fmtflags boolalpha
static const seekdir cur
static const fmtflags dec
static const seekdir end
static const iostate eofbit
static const iostate failbit
static const fmtflags fixed
static const fmtflags floatfield
static const iostate goodbit
static const fmtflags hex
static const openmode in
static const fmtflags internal
static const fmtflags left
static const fmtflags oct
static const openmode out
static const fmtflags right
static const fmtflags scientific
static const fmtflags showbase
static const fmtflags showpoint
static const fmtflags showpos
static const fmtflags skipws
static const openmode trunc
static const fmtflags unitbuf
static const fmtflags uppercase

  Protected Types
enum { _S_local_word_size }
_S_local_word_size

  Protected Member Functions
void _M_cache_locale (const locale &__loc)
void _M_call_callbacks (event __ev) throw ()
void _M_dispose_callbacks (void)
_Words & _M_grow_words (int __index, bool __iword)
void _M_init ()
void init (basic_streambuf< _CharT, _Traits > *__sb)

  Protected Attributes
_Callback_list * _M_callbacks
const __ctype_type * _M_ctype
char_type _M_fill
bool _M_fill_init
streamsize _M_gcount
locale _M_ios_locale
_Words _M_local_word [_S_local_word_size]
const __num_get_type * _M_num_get
const __num_put_type * _M_num_put
basic_streambuf< _CharT, _Traits > * _M_streambuf
basic_ostream< _CharT, _Traits > * _M_tie
_Words * _M_word
int _M_word_size
_Words _M_word_zero

iostate _M_exception
fmtflags _M_flags
streamsize _M_precision
iostate _M_streambuf_state
streamsize _M_width

  Friends
template<typename _CharT2, typename _Traits2> basic_istream< _CharT2, _Traits2 > & operator>> (basic_istream< _CharT2, _Traits2 > &, _CharT2 *)
template<typename _CharT2, typename _Traits2> basic_istream< _CharT2, _Traits2 > & operator>> (basic_istream< _CharT2, _Traits2 > &, _CharT2 &)
class sentry

Member Typedef Documentation

  typedef _CharT char_type

These are standard types. They permit a standardized way of referring to names of (or names dependant on) the template parameters, which are specific to the implementation.

Reimplemented from basic_istream.

Definition at line 407 of file fstream.

  typedef void(*) event_callback(event, ios_base &, int) [inherited]

The type of an event callback function.

Parameters:
    event One of the members of the event enum.
    ios_base Reference to the ios_base object.
    int The integer provided when the callback was registered.

Event callbacks are user defined functions that get called during several ios_base and basic_ios functions, specifically imbue(), copyfmt(), and ~ios().

Definition at line 435 of file ios_base.h.

  typedef _Ios_Fmtflags fmtflags [inherited]

This is a bitmask type.

'_Ios_Fmtflags' is implementation-defined, but it is valid to perform bitwise operations on these values and expect the Right Thing to happen. Defined objects of type fmtflags are:

•   boolalpha

•   dec

•   fixed

•   hex

•   internal

•   left

•   oct

•   right

•   scientific

•   showbase

•   showpoint

•   showpos

•   skipws

•   unitbuf

•   uppercase

•   adjustfield

•   basefield

•   floatfield

Definition at line 253 of file ios_base.h.

  typedef traits_type::int_type int_type

These are standard types. They permit a standardized way of referring to names of (or names dependant on) the template parameters, which are specific to the implementation.

Reimplemented from basic_istream.

Definition at line 409 of file fstream.

  typedef _Ios_Iostate iostate [inherited]

This is a bitmask type.

'_Ios_Iostate' is implementation-defined, but it is valid to perform bitwise operations on these values and expect the Right Thing to happen. Defined objects of type iostate are:

•   badbit

•   eofbit

•   failbit

•   goodbit

Definition at line 328 of file ios_base.h.

  typedef traits_type::off_type off_type

These are standard types. They permit a standardized way of referring to names of (or names dependant on) the template parameters, which are specific to the implementation.

Reimplemented from basic_istream.

Definition at line 411 of file fstream.

  typedef _Ios_Openmode openmode [inherited]

This is a bitmask type.

'_Ios_Openmode' is implementation-defined, but it is valid to perform bitwise operations on these values and expect the Right Thing to happen. Defined objects of type openmode are:

•   app

•   ate

•   binary

•   in

•   out

•   trunc

Definition at line 359 of file ios_base.h.

  typedef traits_type::pos_type pos_type

These are standard types. They permit a standardized way of referring to names of (or names dependant on) the template parameters, which are specific to the implementation.

Reimplemented from basic_istream.

Definition at line 410 of file fstream.

  typedef _Ios_Seekdir seekdir [inherited]

This is an enumerated type.

'_Ios_Seekdir' is implementation-defined. Defined values of type seekdir are:

•   beg

•   cur, equivalent to SEEK_CUR in the C standard library.

•   end, equivalent to SEEK_END in the C standard library.

Definition at line 392 of file ios_base.h.

  typedef _Traits traits_type

These are standard types. They permit a standardized way of referring to names of (or names dependant on) the template parameters, which are specific to the implementation.

Reimplemented from basic_istream.

Definition at line 408 of file fstream.

Member Enumeration Documentation

  enum event [inherited]

The set of events that may be passed to an event callback.

erase_event is used during ~ios() and copyfmt(). imbue_event is used during imbue(). copyfmt_event is used during copyfmt().

Definition at line 418 of file ios_base.h.

Constructor & Destructor Documentation

  basic_ifstream () [inline]

Default constructor.

Initializes sb using its default constructor, and passes &sb to the base class initializer. Does not open any files (you haven't given it a filename to open).

Definition at line 429 of file fstream.

References basic_ios::init().

  basic_ifstream (const char * __s, ios_base::openmode __mode = ios_base::in) [inline, explicit]

Create an input file stream.

Parameters:
    s Null terminated string specifying the filename.
    mode Open file in specified mode (see std::ios_base).

ios_base::in is automatically included in mode.

Tip: When using std::string to hold the filename, you must use .c_str() before passing it to this constructor.

Definition at line 443 of file fstream.

References basic_ios::init(), and basic_ifstream::open().

  ~basic_ifstream () [inline]

The destructor does nothing.

The file is closed by the filebuf object, not the formatting stream.

Definition at line 456 of file fstream.

Member Function Documentation

  const locale& _M_getloc () const [inline, inherited]

Locale access.

Returns:
    A reference to the current locale.

Like getloc above, but returns a reference instead of generating a copy.

Definition at line 700 of file ios_base.h.

References ios_base::_M_ios_locale.

Referenced by money_get::_M_extract(), num_get::_M_extract_float(), num_get::_M_extract_int(), time_get::_M_extract_name(), time_get::_M_extract_num(), time_get::_M_extract_via_format(), money_put::_M_insert(), num_put::_M_insert_float(), num_put::_M_insert_int(), __pad::_S_pad(), money_get::do_get(), num_get::do_get(), time_get::do_get_date(), time_get::do_get_monthname(), time_get::do_get_time(), time_get::do_get_weekday(), time_get::do_get_year(), time_put::do_put(), num_put::do_put(), and time_put::put().

  bool bad () const [inline, inherited]

Fast error checking.

Returns:
    True if the badbit is set.

Note that other iostate flags may also be set.

Definition at line 197 of file basic_ios.h.

References ios_base::badbit.

  void clear (iostate __state = goodbit) [inherited]

[Re]sets the error state.

Parameters:
    state The new state flag(s) to set.

See std::ios_base::iostate for the possible bit values. Most users will not need to pass an argument.

Definition at line 44 of file basic_ios.tcc.

References ios_base::_M_streambuf_state, ios_base::badbit, and basic_ios::rdstate().

Referenced by basic_ios::exceptions(), basic_fstream::open(), basic_ofstream::open(), basic_ifstream::open(), basic_ios::rdbuf(), and basic_ios::setstate().

  void close () [inline]

Close the file.

Calls std::basic_filebuf::close(). If that function fails, failbit is set in the stream's error state.

Definition at line 513 of file fstream.

References basic_filebuf::close(), and ios_base::failbit.

  basic_ios< _CharT, _Traits > & copyfmt (const basic_ios< _CharT, _Traits > & __rhs) [inherited]

Copies fields of __rhs into this.

Parameters:
    __rhs The source values for the copies.

Returns:
    Reference to this object.

All fields of __rhs are copied into this object except that rdbuf() and rdstate() remain unchanged. All values in the pword and iword arrays are copied. Before copying, each callback is invoked with erase_event. After copying, each (new) callback is invoked with copyfmt_event. The final step is to copy exceptions().

Definition at line 66 of file basic_ios.tcc.

References basic_ios::_M_cache_locale(), ios_base::_M_callbacks, ios_base::_M_ios_locale, ios_base::_M_local_word, ios_base::_M_word, ios_base::_M_word_size, basic_ios::exceptions(), basic_ios::fill(), ios_base::flags(), ios_base::getloc(), ios_base::precision(), basic_ios::tie(), and ios_base::width().

  bool eof () const [inline, inherited]

Fast error checking.

Returns:
    True if the eofbit is set.

Note that other iostate flags may also be set.

Definition at line 176 of file basic_ios.h.

References ios_base::eofbit.

  void exceptions (iostate __except) [inline, inherited]

Throwing exceptions on errors.

Parameters:
    except The new exceptions mask.

By default, error flags are set silently. You can set an exceptions mask for each stream; if a bit in the mask becomes set in the error flags, then an exception of type std::ios_base::failure is thrown.

If the error flage is already set when the exceptions mask is added, the exception is immediately thrown. Try running the following under GCC 3.1 or later:

  #include <iostream>
  #include <fstream>
  #include <exception>
  int main()
  {
      std::set_terminate (__gnu_cxx::__verbose_terminate_handler);
      std::ifstream f ('/etc/motd');
      std::cerr << 'Setting badbit;
      f.setstate (std::ios_base::badbit);
      std::cerr << 'Setting exception mask;
      f.exceptions (std::ios_base::badbit);
  }

Definition at line 243 of file basic_ios.h.

References ios_base::_M_exception, ios_base::_M_streambuf_state, and basic_ios::clear().

  iostate exceptions () const [inline, inherited]

Throwing exceptions on errors.

Returns:
    The current exceptions mask.

This changes nothing in the stream. See the one-argument version of exceptions(iostate) for the meaning of the return value.

Definition at line 208 of file basic_ios.h.

References ios_base::_M_exception.

Referenced by basic_ios::copyfmt().

  bool fail () const [inline, inherited]

Fast error checking.

Returns:
    True if either the badbit or the failbit is set.

Checking the badbit in fail() is historical practice. Note that other iostate flags may also be set.

Definition at line 187 of file basic_ios.h.

References ios_base::badbit, and ios_base::failbit.

Referenced by basic_ios::operator void *(), and basic_ios::operator!().

  char_type fill (char_type __ch) [inline, inherited]

Sets a new 'empty' character.

Parameters:
    ch The new character.

Returns:
    The previous fill character.

The fill character is used to fill out space when P+ characters have been requested (e.g., via setw), Q characters are actually used, and Q<P. It defaults to a space (' ') in the current locale.

Definition at line 376 of file basic_ios.h.

References basic_ios::_M_fill, and basic_ios::fill().

  char_type fill () const [inline, inherited]

Retreives the 'empty' character.

Returns:
    The current fill character.

It defaults to a space (' ') in the current locale.

Definition at line 356 of file basic_ios.h.

References basic_ios::_M_fill, basic_ios::_M_fill_init, and basic_ios::widen().

Referenced by basic_ios::copyfmt(), basic_ios::fill(), std::operator<<(), and std::operator>>().

  fmtflags flags (fmtflags __fmtfl) [inline, inherited]

Setting new format flags all at once.

Parameters:
    fmtfl The new flags to set.

Returns:
    The previous format control flags.

This function overwrites all the format flags with fmtfl.

Definition at line 558 of file ios_base.h.

References ios_base::_M_flags.

  fmtflags flags () const [inline, inherited]

Access to format flags.

Returns:
    The format control flags for both input and output.

Definition at line 548 of file ios_base.h.

References ios_base::_M_flags.

Referenced by money_get::_M_extract(), num_get::_M_extract_int(), money_put::_M_insert(), num_put::_M_insert_float(), num_put::_M_insert_int(), __pad::_S_pad(), basic_ios::copyfmt(), num_get::do_get(), num_put::do_put(), __gnu_cxx::operator<<(), basic_ostream::operator<<(), and basic_istream::sentry::sentry().

  streamsize gcount () const [inline, inherited]

Character counting.

Returns:
    The number of characters extracted by the previous unformatted input function dispatched for this stream.

Definition at line 241 of file istream.

References basic_istream::_M_gcount.

  __istream_type& get (__streambuf_type & __sb) [inline, inherited]

Extraction into another streambuf.

Parameters:
    sb A streambuf in which to store data.

Returns:
    *this

Returns get(sb,widen('

Definition at line 358 of file istream.

References basic_istream::get().

  basic_istream< _CharT, _Traits > & get (__streambuf_type & __sb, char_type __delim) [inherited]

Extraction into another streambuf.

Parameters:
    sb A streambuf in which to store data.
    delim A 'stop' character.

Returns:
    *this

Characters are extracted and inserted into sb until one of the following happens:

•   the input sequence reaches EOF

•   insertion into the output buffer fails (in this case, the character that would have been inserted is not extracted)

•   the next character equals delim (in this case, the character is not extracted)

•   an exception occurs (and in this case is caught)

If no characters are stored, failbit is set in the stream's error state.

Definition at line 550 of file istream.tcc.

References basic_istream::_M_gcount, basic_ios::_M_setstate(), ios_base::badbit, ios_base::eofbit, ios_base::failbit, ios_base::goodbit, basic_ios::rdbuf(), basic_ios::setstate(), basic_streambuf::sgetc(), basic_streambuf::snextc(), and basic_streambuf::sputc().

  __istream_type& get (char_type * __s, streamsize __n) [inline, inherited]

Simple multiple-character extraction.

Parameters:
    s Pointer to an array.
    n Maximum number of characters to store in s.

Returns:
    *this

Returns get(s,n,widen('

Definition at line 325 of file istream.

References basic_istream::get().

  basic_istream< _CharT, _Traits > & get (char_type * __s, streamsize __n, char_type __delim) [inherited]

Simple multiple-character extraction.

Parameters:
    s Pointer to an array.
    n Maximum number of characters to store in s.
    delim A 'stop' character.

Returns:
    *this

Characters are extracted and stored into s until one of the following happens:

•   n-1 characters are stored

•   the input sequence reaches EOF

•   the next character equals delim, in which case the character is not extracted

If no characters are stored, failbit is set in the stream's error state.

In any case, a null character is stored into the next location in the array.

Note:
    This function is not overloaded on signed char and unsigned char.

Definition at line 508 of file istream.tcc.

References basic_istream::_M_gcount, basic_ios::_M_setstate(), ios_base::badbit, ios_base::eofbit, ios_base::failbit, ios_base::goodbit, basic_ios::rdbuf(), basic_ios::setstate(), basic_streambuf::sgetc(), and basic_streambuf::snextc().

  basic_istream< _CharT, _Traits > & get (char_type & __c) [inherited]

Simple extraction.

Parameters:
    c The character in which to store data.

Returns:
    *this

Tries to extract a character and store it in c. If none are available, sets failbit and returns traits::eof().

Note:
    This function is not overloaded on signed char and unsigned char.

Definition at line 476 of file istream.tcc.

References basic_istream::_M_gcount, basic_ios::_M_setstate(), ios_base::badbit, ios_base::eofbit, ios_base::failbit, ios_base::goodbit, basic_ios::rdbuf(), and basic_ios::setstate().

  basic_istream< _CharT, _Traits >::int_type get () [inherited]

Simple extraction.

Returns:
    A character, or eof().

Tries to extract a character. If none are available, sets failbit and returns traits::eof().

Definition at line 445 of file istream.tcc.

References basic_istream::_M_gcount, basic_ios::_M_setstate(), ios_base::badbit, ios_base::eofbit, ios_base::failbit, ios_base::goodbit, basic_ios::rdbuf(), and basic_ios::setstate().

Referenced by basic_istream::get().

  __istream_type& getline (char_type * __s, streamsize __n) [inline, inherited]

String extraction.

Parameters:
    s A character array in which to store the data.
    n Maximum number of characters to extract.

Returns:
    *this

Returns getline(s,n,widen('

Definition at line 398 of file istream.

References basic_istream::getline().

  basic_istream< _CharT, _Traits > & getline (char_type * __s, streamsize __n, char_type __delim) [inherited]

String extraction.

Parameters:
    s A character array in which to store the data.
    n Maximum number of characters to extract.
    delim A 'stop' character.

Returns:
    *this

Extracts and stores characters into s until one of the following happens. Note that these criteria are required to be tested in the order listed here, to allow an input line to exactly fill the s array without setting failbit.

1.  the input sequence reaches end-of-file, in which case eofbit is set in the stream error state

2.  the next character equals delim, in which case the character is extracted (and therefore counted in gcount()) but not stored

3.  n-1 characters are stored, in which case failbit is set in the stream error state

If no characters are extracted, failbit is set. (An empty line of input should therefore not cause failbit to be set.)

In any case, a null character is stored in the next location in the array.

Definition at line 589 of file istream.tcc.

References basic_istream::_M_gcount, basic_ios::_M_setstate(), ios_base::badbit, ios_base::eofbit, ios_base::failbit, ios_base::goodbit, basic_ios::rdbuf(), basic_streambuf::sbumpc(), basic_ios::setstate(), basic_streambuf::sgetc(), and basic_streambuf::snextc().

Referenced by basic_istream::getline().

  locale getloc () const [inline, inherited]

Locale access.

Returns:
    A copy of the current locale.

If imbue(loc) has previously been called, then this function returns loc. Otherwise, it returns a copy of std::locale(), the global C++ locale.

Definition at line 690 of file ios_base.h.

References ios_base::_M_ios_locale.

Referenced by basic_ios::copyfmt(), money_put::do_put(), std::operator>>(), and std::ws().

  bool good () const [inline, inherited]

Fast error checking.

Returns:
    True if no error flags are set.

A wrapper around rdstate.

Definition at line 166 of file basic_ios.h.

References basic_ios::rdstate().

Referenced by basic_ostream::sentry::sentry(), and basic_istream::sentry::sentry().

  basic_istream< _CharT, _Traits > & ignore (streamsize __n, int_type __delim) [inherited]

Extraction into another streambuf.

Parameters:
    sb A streambuf in which to store data.

Returns:
    *this

Returns get(sb,widen('

Definition at line 728 of file istream.tcc.

References basic_istream::_M_gcount, basic_ios::_M_setstate(), ios_base::badbit, ios_base::eofbit, ios_base::goodbit, std::max(), std::min(), basic_ios::rdbuf(), basic_streambuf::sbumpc(), basic_ios::setstate(), basic_streambuf::sgetc(), and basic_streambuf::snextc().

  basic_istream< _CharT, _Traits > & ignore (streamsize __n) [inherited]

Extraction into another streambuf.

Parameters:
    sb A streambuf in which to store data.

Returns:
    *this

Returns get(sb,widen('

Definition at line 672 of file istream.tcc.

References basic_istream::_M_gcount, basic_ios::_M_setstate(), ios_base::badbit, ios_base::eofbit, ios_base::goodbit, std::max(), std::min(), basic_ios::rdbuf(), basic_ios::setstate(), basic_streambuf::sgetc(), and basic_streambuf::snextc().

  basic_istream< _CharT, _Traits > & ignore () [inherited]

Discarding characters.

Parameters:
    n Number of characters to discard.
    delim A 'stop' character.

Returns:
    *this

Extracts characters and throws them away until one of the following happens:

•   if n != std::numeric_limits<int>::max(), n characters are extracted

•   the input sequence reaches end-of-file

•   the next character equals delim (in this case, the character is extracted); note that this condition will never occur if delim equals traits::eof().

NB: Provide three overloads, instead of the single function (with defaults) mandated by the Standard: this leads to a better performing implementation, while still conforming to the Standard.

Definition at line 644 of file istream.tcc.

References basic_istream::_M_gcount, basic_ios::_M_setstate(), ios_base::badbit, ios_base::eofbit, ios_base::goodbit, basic_ios::rdbuf(), basic_streambuf::sbumpc(), and basic_ios::setstate().

  locale imbue (const locale & __loc) [inherited]

Moves to a new locale.

Parameters:
    loc The new locale.

Returns:
    The previous locale.

Calls ios_base::imbue(loc), and if a stream buffer is associated with this stream, calls that buffer's pubimbue(loc).

Additional l10n notes are at http://gcc.gnu.org/onlinedocs/libstdc++/22_locale/howto.html

Reimplemented from ios_base.

Definition at line 127 of file basic_ios.tcc.

References basic_ios::_M_cache_locale(), and ios_base::imbue().

  void init (basic_streambuf< _CharT, _Traits > * __sb) [protected, inherited]

All setup is performed here.

This is called from the public constructor. It is not virtual and cannot be redefined.

Definition at line 139 of file basic_ios.tcc.

References basic_ios::_M_cache_locale(), ios_base::_M_exception, basic_ios::_M_fill, basic_ios::_M_fill_init, ios_base::_M_ios_locale, basic_ios::_M_streambuf, ios_base::_M_streambuf_state, basic_ios::_M_tie, ios_base::badbit, and ios_base::goodbit.

Referenced by basic_fstream::basic_fstream(), basic_ifstream::basic_ifstream(), basic_ios::basic_ios(), basic_iostream::basic_iostream(), basic_istream::basic_istream(), basic_istringstream::basic_istringstream(), basic_ofstream::basic_ofstream(), basic_ostream::basic_ostream(), basic_ostringstream::basic_ostringstream(), and basic_stringstream::basic_stringstream().

  bool is_open () [inline]

Wrapper to test for an open file.

Returns:
    rdbuf()->is_open()

Definition at line 475 of file fstream.

References basic_filebuf::is_open().

  long& iword (int __ix) [inline, inherited]

Access to integer array.

Parameters:
    __ix Index into the array.

Returns:
    A reference to an integer associated with the index.

The iword function provides access to an array of integers that can be used for any purpose. The array grows as required to hold the supplied index. All integers in the array are initialized to 0.

The implementation reserves several indices. You should use xalloc to obtain an index that is safe to use. Also note that since the array can grow dynamically, it is not safe to hold onto the reference.

Definition at line 734 of file ios_base.h.

References ios_base::_Words::_M_iword, ios_base::_M_word, and ios_base::_M_word_size.

  char narrow (char_type __c, char __dfault) const [inherited]

Squeezes characters.

Parameters:
    c The character to narrow.
    dfault The character to narrow.

Returns:
    The narrowed character.

Maps a character of char_type to a character of char, if possible.

Returns the result of

    std::use_facet<ctype<char_type> >(getloc()).narrow(c,dfault)

Additional l10n notes are at http://gcc.gnu.org/onlinedocs/libstdc++/22_locale/howto.html

Definition at line 116 of file basic_ios.tcc.

References std::__check_facet(), and basic_ios::_M_ctype.

  void open (const char * __s, ios_base::openmode __mode = ios_base::in) [inline]

Opens an external file.

Parameters:
    s The name of the file.
    mode The open mode flags.

Calls std::basic_filebuf::open(s,mode|in). If that function fails, failbit is set in the stream's error state.

Tip: When using std::string to hold the filename, you must use .c_str() before passing it to this constructor.

Definition at line 496 of file fstream.

References basic_ios::clear(), ios_base::failbit, ios_base::in, and basic_filebuf::open().

Referenced by basic_ifstream::basic_ifstream().

  operator void * () const [inline, inherited]

The quick-and-easy status check.

This allows you to write constructs such as 'if (!a_stream) ...' and 'while (a_stream) ...'

Definition at line 107 of file basic_ios.h.

References basic_ios::fail().

  bool operator! () const [inline, inherited]

The quick-and-easy status check.

This allows you to write constructs such as 'if (!a_stream) ...' and 'while (a_stream) ...'

Definition at line 111 of file basic_ios.h.

References basic_ios::fail().

  basic_istream< _CharT, _Traits > & operator>> (__streambuf_type * __sb) [inherited]

Extracting into another streambuf.

Parameters:
    sb A pointer to a streambuf

This function behaves like one of the basic arithmetic extractors, in that it also constructs a sentry object and has the same error handling behavior.

If sb is NULL, the stream will set failbit in its error state.

Characters are extracted from this stream and inserted into the sb streambuf until one of the following occurs:

•   the input stream reaches end-of-file,

•   insertion into the output buffer fails (in this case, the character that would have been inserted is not extracted), or

•   an exception occurs (and in this case is caught)

If the function inserts no characters, failbit is set.

Definition at line 421 of file istream.tcc.

References std::__copy_streambufs(), basic_ios::_M_setstate(), ios_base::failbit, ios_base::goodbit, and basic_ios::setstate().

  basic_istream< _CharT, _Traits > & operator>> (void *& __p) [inherited]

Extracting into another streambuf.

Parameters:
    sb A pointer to a streambuf

This function behaves like one of the basic arithmetic extractors, in that it also constructs a sentry object and has the same error handling behavior.

If sb is NULL, the stream will set failbit in its error state.

Characters are extracted from this stream and inserted into the sb streambuf until one of the following occurs:

•   the input stream reaches end-of-file,

•   insertion into the output buffer fails (in this case, the character that would have been inserted is not extracted), or

•   an exception occurs (and in this case is caught)

If the function inserts no characters, failbit is set.

Definition at line 399 of file istream.tcc.

References std::__check_facet(), basic_ios::_M_setstate(), ios_base::badbit, num_get::get(), ios_base::goodbit, and basic_ios::setstate().

  basic_istream< _CharT, _Traits > & operator>> (long double & __f) [inherited]

Extracting into another streambuf.

Parameters:
    sb A pointer to a streambuf

This function behaves like one of the basic arithmetic extractors, in that it also constructs a sentry object and has the same error handling behavior.

If sb is NULL, the stream will set failbit in its error state.

Characters are extracted from this stream and inserted into the sb streambuf until one of the following occurs:

•   the input stream reaches end-of-file,

•   insertion into the output buffer fails (in this case, the character that would have been inserted is not extracted), or

•   an exception occurs (and in this case is caught)

If the function inserts no characters, failbit is set.

Definition at line 377 of file istream.tcc.

References std::__check_facet(), basic_ios::_M_setstate(), ios_base::badbit, num_get::get(), ios_base::goodbit, and basic_ios::setstate().

  basic_istream< _CharT, _Traits > & operator>> (double & __f) [inherited]

Extracting into another streambuf.

Parameters:
    sb A pointer to a streambuf

This function behaves like one of the basic arithmetic extractors, in that it also constructs a sentry object and has the same error handling behavior.

If sb is NULL, the stream will set failbit in its error state.

Characters are extracted from this stream and inserted into the sb streambuf until one of the following occurs:

•   the input stream reaches end-of-file,

•   insertion into the output buffer fails (in this case, the character that would have been inserted is not extracted), or

•   an exception occurs (and in this case is caught)

If the function inserts no characters, failbit is set.

Definition at line 355 of file istream.tcc.

References std::__check_facet(), basic_ios::_M_setstate(), ios_base::badbit, num_get::get(), ios_base::goodbit, and basic_ios::setstate().

  basic_istream< _CharT, _Traits > & operator>> (float & __f) [inherited]

Extracting into another streambuf.

Parameters:
    sb A pointer to a streambuf

This function behaves like one of the basic arithmetic extractors, in that it also constructs a sentry object and has the same error handling behavior.

If sb is NULL, the stream will set failbit in its error state.

Characters are extracted from this stream and inserted into the sb streambuf until one of the following occurs:

•   the input stream reaches end-of-file,

•   insertion into the output buffer fails (in this case, the character that would have been inserted is not extracted), or

•   an exception occurs (and in this case is caught)

If the function inserts no characters, failbit is set.

Definition at line 333 of file istream.tcc.

References std::__check_facet(), basic_ios::_M_setstate(), ios_base::badbit, num_get::get(), ios_base::goodbit, and basic_ios::setstate().

  basic_istream< _CharT, _Traits > & operator>> (unsigned long long & __n) [inherited]

Extracting into another streambuf.

Parameters:
    sb A pointer to a streambuf

This function behaves like one of the basic arithmetic extractors, in that it also constructs a sentry object and has the same error handling behavior.

If sb is NULL, the stream will set failbit in its error state.

Characters are extracted from this stream and inserted into the sb streambuf until one of the following occurs:

•   the input stream reaches end-of-file,

•   insertion into the output buffer fails (in this case, the character that would have been inserted is not extracted), or

•   an exception occurs (and in this case is caught)

If the function inserts no characters, failbit is set.

Definition at line 310 of file istream.tcc.

References std::__check_facet(), basic_ios::_M_setstate(), ios_base::badbit, num_get::get(), ios_base::goodbit, and basic_ios::setstate().

  basic_istream< _CharT, _Traits > & operator>> (long long & __n) [inherited]

Extracting into another streambuf.

Parameters:
    sb A pointer to a streambuf

This function behaves like one of the basic arithmetic extractors, in that it also constructs a sentry object and has the same error handling behavior.

If sb is NULL, the stream will set failbit in its error state.

Characters are extracted from this stream and inserted into the sb streambuf until one of the following occurs:

•   the input stream reaches end-of-file,

•   insertion into the output buffer fails (in this case, the character that would have been inserted is not extracted), or

•   an exception occurs (and in this case is caught)

If the function inserts no characters, failbit is set.

Definition at line 288 of file istream.tcc.

References std::__check_facet(), basic_ios::_M_setstate(), ios_base::badbit, num_get::get(), ios_base::goodbit, and basic_ios::setstate().

  basic_istream< _CharT, _Traits > & operator>> (unsigned long & __n) [inherited]

Extracting into another streambuf.

Parameters:
    sb A pointer to a streambuf

This function behaves like one of the basic arithmetic extractors, in that it also constructs a sentry object and has the same error handling behavior.

If sb is NULL, the stream will set failbit in its error state.

Characters are extracted from this stream and inserted into the sb streambuf until one of the following occurs:

•   the input stream reaches end-of-file,

•   insertion into the output buffer fails (in this case, the character that would have been inserted is not extracted), or

•   an exception occurs (and in this case is caught)

If the function inserts no characters, failbit is set.

Definition at line 265 of file istream.tcc.

References std::__check_facet(), basic_ios::_M_setstate(), ios_base::badbit, num_get::get(), ios_base::goodbit, and basic_ios::setstate().

  basic_istream< _CharT, _Traits > & operator>> (long & __n) [inherited]

Extracting into another streambuf.

Parameters:
    sb A pointer to a streambuf

This function behaves like one of the basic arithmetic extractors, in that it also constructs a sentry object and has the same error handling behavior.

If sb is NULL, the stream will set failbit in its error state.

Characters are extracted from this stream and inserted into the sb streambuf until one of the following occurs:

•   the input stream reaches end-of-file,

•   insertion into the output buffer fails (in this case, the character that would have been inserted is not extracted), or

•   an exception occurs (and in this case is caught)

If the function inserts no characters, failbit is set.

Definition at line 243 of file istream.tcc.

References std::__check_facet(), basic_ios::_M_setstate(), ios_base::badbit, num_get::get(), ios_base::goodbit, and basic_ios::setstate().

  basic_istream< _CharT, _Traits > & operator>> (unsigned int & __n) [inherited]

Extracting into another streambuf.

Parameters:
    sb A pointer to a streambuf

This function behaves like one of the basic arithmetic extractors, in that it also constructs a sentry object and has the same error handling behavior.

If sb is NULL, the stream will set failbit in its error state.

Characters are extracted from this stream and inserted into the sb streambuf until one of the following occurs:

•   the input stream reaches end-of-file,

•   insertion into the output buffer fails (in this case, the character that would have been inserted is not extracted), or

•   an exception occurs (and in this case is caught)

If the function inserts no characters, failbit is set.

Definition at line 221 of file istream.tcc.

References std::__check_facet(), basic_ios::_M_setstate(), ios_base::badbit, num_get::get(), ios_base::goodbit, and basic_ios::setstate().

  basic_istream< _CharT, _Traits > & operator>> (int & __n) [inherited]

Extracting into another streambuf.

Parameters:
    sb A pointer to a streambuf

This function behaves like one of the basic arithmetic extractors, in that it also constructs a sentry object and has the same error handling behavior.

If sb is NULL, the stream will set failbit in its error state.

Characters are extracted from this stream and inserted into the sb streambuf until one of the following occurs:

•   the input stream reaches end-of-file,

•   insertion into the output buffer fails (in this case, the character that would have been inserted is not extracted), or

•   an exception occurs (and in this case is caught)

If the function inserts no characters, failbit is set.

Definition at line 190 of file istream.tcc.

References std::__check_facet(), basic_ios::_M_setstate(), ios_base::badbit, ios_base::failbit, num_get::get(), ios_base::goodbit, and basic_ios::setstate().

  basic_istream< _CharT, _Traits > & operator>> (unsigned short & __n) [inherited]

Extracting into another streambuf.

Parameters:
    sb A pointer to a streambuf

This function behaves like one of the basic arithmetic extractors, in that it also constructs a sentry object and has the same error handling behavior.

If sb is NULL, the stream will set failbit in its error state.

Characters are extracted from this stream and inserted into the sb streambuf until one of the following occurs:

•   the input stream reaches end-of-file,

•   insertion into the output buffer fails (in this case, the character that would have been inserted is not extracted), or

•   an exception occurs (and in this case is caught)

If the function inserts no characters, failbit is set.

Definition at line 168 of file istream.tcc.

References std::__check_facet(), basic_ios::_M_setstate(), ios_base::badbit, num_get::get(), ios_base::goodbit, and basic_ios::setstate().

  basic_istream< _CharT, _Traits > & operator>> (short & __n) [inherited]

Extracting into another streambuf.

Parameters:
    sb A pointer to a streambuf

This function behaves like one of the basic arithmetic extractors, in that it also constructs a sentry object and has the same error handling behavior.

If sb is NULL, the stream will set failbit in its error state.

Characters are extracted from this stream and inserted into the sb streambuf until one of the following occurs:

•   the input stream reaches end-of-file,

•   insertion into the output buffer fails (in this case, the character that would have been inserted is not extracted), or

•   an exception occurs (and in this case is caught)

If the function inserts no characters, failbit is set.

Definition at line 137 of file istream.tcc.

References std::__check_facet(), basic_ios::_M_setstate(), ios_base::badbit, ios_base::failbit, num_get::get(), ios_base::goodbit, and basic_ios::setstate().

  basic_istream< _CharT, _Traits > & operator>> (bool & __n) [inherited]

Basic arithmetic extractors.

Parameters:
    A variable of builtin type.

Returns:
    *this if successful

These functions use the stream's current locale (specifically, the num_get facet) to parse the input data.

Definition at line 115 of file istream.tcc.

References std::__check_facet(), basic_ios::_M_setstate(), ios_base::badbit, num_get::get(), ios_base::goodbit, and basic_ios::setstate().

  basic_istream< _CharT, _Traits > & operator>> (__istream_type &(*)(__istream_type &) __pf) [inline, inherited]

Interface for manipulators.

Manuipulators such as std::ws and std::dec use these functions in constructs like 'std::cin >> std::ws'. For more information, see the iomanip header.

Definition at line 91 of file istream.tcc.

  basic_istream< _CharT, _Traits >::int_type peek () [inherited]

Looking ahead in the stream.

Returns:
    The next character, or eof().

If, after constructing the sentry object, good() is false, returns traits::eof(). Otherwise reads but does not extract the next input character.

Definition at line 786 of file istream.tcc.

References basic_istream::_M_gcount, basic_ios::_M_setstate(), ios_base::badbit, ios_base::eofbit, ios_base::goodbit, basic_ios::rdbuf(), and basic_ios::setstate().

  streamsize precision (streamsize __prec) [inline, inherited]

Changing flags.

Parameters:
    prec The new precision value.

Returns:
    The previous value of precision().

Definition at line 626 of file ios_base.h.

References ios_base::_M_precision.

  streamsize precision () const [inline, inherited]

Flags access.

Returns:
    The precision to generate on certain output operations.

Definition at line 618 of file ios_base.h.

References ios_base::_M_precision.

Referenced by num_put::_M_insert_float(), basic_ios::copyfmt(), std::operator<<(), and std::operator>>().

  basic_istream< _CharT, _Traits > & putback (char_type __c) [inherited]

Unextracting a single character.

Parameters:
    c The character to push back into the input stream.

Returns:
    *this

If rdbuf() is not null, calls rdbuf()->sputbackc(c).

If rdbuf() is null or if sputbackc() fails, sets badbit in the error state.

Note:
    Since no characters are extracted, the next call to gcount() will return 0, as required by DR 60.

Definition at line 862 of file istream.tcc.

References basic_istream::_M_gcount, basic_ios::_M_setstate(), ios_base::badbit, ios_base::goodbit, basic_ios::rdbuf(), basic_ios::setstate(), and basic_streambuf::sputbackc().

  void*& pword (int __ix) [inline, inherited]

Access to void pointer array.

Parameters:
    __ix Index into the array.

Returns:
    A reference to a void* associated with the index.

The pword function provides access to an array of pointers that can be used for any purpose. The array grows as required to hold the supplied index. All pointers in the array are initialized to 0.

The implementation reserves several indices. You should use xalloc to obtain an index that is safe to use. Also note that since the array can grow dynamically, it is not safe to hold onto the reference.

Definition at line 755 of file ios_base.h.

References ios_base::_Words::_M_pword, ios_base::_M_word, and ios_base::_M_word_size.

  basic_streambuf< _CharT, _Traits > * rdbuf (basic_streambuf< _CharT, _Traits > * __sb) [inherited]

Changing the underlying buffer.

Parameters:
    sb The new stream buffer.

Returns:
    The previous stream buffer.

Associates a new buffer with the current stream, and clears the error state.

Due to historical accidents which the LWG refuses to correct, the I/O library suffers from a design error: this function is hidden in derived classes by overrides of the zero-argument rdbuf(), which is non-virtual for hysterical raisins. As a result, you must use explicit qualifications to access this function via any derived class. For example:

  std::fstream     foo;         // or some other derived type
  std::streambuf*  p = .....;
  foo.ios::rdbuf(p);            // ios == basic_ios<char>

Definition at line 56 of file basic_ios.tcc.

References basic_ios::_M_streambuf, and basic_ios::clear().

  __filebuf_type* rdbuf () const [inline]

Accessing the underlying buffer.

Returns:
    The current basic_filebuf buffer.

This hides both signatures of std::basic_ios::rdbuf().

Reimplemented from basic_ios.

Definition at line 467 of file fstream.

  iostate rdstate () const [inline, inherited]

Returns the error state of the stream buffer.

Returns:
    A bit pattern (well, isn't everything?)

See std::ios_base::iostate for the possible bit values. Most users will call one of the interpreting wrappers, e.g., good().

Definition at line 123 of file basic_ios.h.

References ios_base::_M_streambuf_state.

Referenced by basic_ios::clear(), and basic_ios::good().

  basic_istream< _CharT, _Traits > & read (char_type * __s, streamsize __n) [inherited]

Extraction without delimiters.

Parameters:
    s A character array.
    n Maximum number of characters to store.

Returns:
    *this

If the stream state is good(), extracts characters and stores them into s until one of the following happens:

•   n characters are stored

•   the input sequence reaches end-of-file, in which case the error state is set to failbit|eofbit.

Note:
    This function is not overloaded on signed char and unsigned char.

Definition at line 811 of file istream.tcc.

References basic_istream::_M_gcount, basic_ios::_M_setstate(), ios_base::badbit, ios_base::eofbit, ios_base::failbit, ios_base::goodbit, basic_ios::rdbuf(), and basic_ios::setstate().

  streamsize readsome (char_type * __s, streamsize __n) [inherited]

Extraction until the buffer is exhausted, but no more.

Parameters:
    s A character array.
    n Maximum number of characters to store.

Returns:
    The number of characters extracted.

Extracts characters and stores them into s depending on the number of characters remaining in the streambuf's buffer, rdbuf()->in_avail(), called A here:

•   if A == -1, sets eofbit and extracts no characters

•   if A == 0, extracts no characters

•   if A > 0, extracts min(A,n)

The goal is to empty the current buffer, and to not request any more from the external input sequence controlled by the streambuf.

Definition at line 835 of file istream.tcc.

References basic_istream::_M_gcount, basic_ios::_M_setstate(), ios_base::badbit, ios_base::eofbit, ios_base::goodbit, std::min(), basic_ios::rdbuf(), and basic_ios::setstate().

  void register_callback (event_callback __fn, int __index) [inherited]

Add the callback __fn with parameter __index.

Parameters:
    __fn The function to add.
    __index The integer to pass to the function when invoked.

Registers a function as an event callback with an integer parameter to be passed to the function when invoked. Multiple copies of the function are allowed. If there are multiple callbacks, they are invoked in the order they were registered.

  basic_istream< _CharT, _Traits > & seekg (off_type, ios_base::seekdir) [inherited]

Changing the current read position.

Parameters:
    off A file offset object.
    dir The direction in which to seek.

Returns:
    *this

If fail() is not true, calls rdbuf()->pubseekoff(off,dir). If that function fails, sets failbit.

Note:
    This function does not count the number of characters extracted, if any, and therefore does not affect the next call to gcount().

Definition at line 995 of file istream.tcc.

References basic_ios::_M_setstate(), ios_base::badbit, ios_base::failbit, ios_base::goodbit, ios_base::in, and basic_ios::setstate().

  basic_istream< _CharT, _Traits > & seekg (pos_type) [inherited]

Changing the current read position.

Parameters:
    pos A file position object.

Returns:
    *this

If fail() is not true, calls rdbuf()->pubseekpos(pos). If that function fails, sets failbit.

Note:
    This function does not count the number of characters extracted, if any, and therefore does not affect the next call to gcount().

Definition at line 967 of file istream.tcc.

References basic_ios::_M_setstate(), ios_base::badbit, ios_base::failbit, ios_base::goodbit, ios_base::in, and basic_ios::setstate().

  fmtflags setf (fmtflags __fmtfl, fmtflags __mask) [inline, inherited]

Setting new format flags.

Parameters:
    fmtfl Additional flags to set.
    mask The flags mask for fmtfl.

Returns:
    The previous format control flags.

This function clears mask in the format flags, then sets fmtfl & mask. An example mask is ios_base::adjustfield.

Definition at line 591 of file ios_base.h.

References ios_base::_M_flags.

  fmtflags setf (fmtflags __fmtfl) [inline, inherited]

Setting new format flags.

Parameters:
    fmtfl Additional flags to set.

Returns:
    The previous format control flags.

This function sets additional flags in format control. Flags that were previously set remain set.

Definition at line 574 of file ios_base.h.

References ios_base::_M_flags.

Referenced by std::boolalpha(), std::dec(), std::fixed(), std::hex(), std::internal(), std::left(), std::oct(), std::operator<<(), std::operator>>(), std::right(), std::scientific(), std::showbase(), std::showpoint(), std::showpos(), std::skipws(), std::unitbuf(), and std::uppercase().

  void setstate (iostate __state) [inline, inherited]

Sets additional flags in the error state.

Parameters:
    state The additional state flag(s) to set.

See std::ios_base::iostate for the possible bit values.

Definition at line 143 of file basic_ios.h.

References basic_ios::clear().

Referenced by basic_ostream::_M_write(), basic_ostream::flush(), basic_istream::get(), std::getline(), basic_istream::getline(), basic_istream::ignore(), basic_ostream::operator<<(), basic_istream::operator>>(), std::operator>>(), basic_istream::peek(), basic_ostream::put(), basic_istream::putback(), basic_istream::read(), basic_istream::readsome(), basic_istream::seekg(), basic_ostream::seekp(), basic_ostream::sentry::sentry(), basic_istream::sentry::sentry(), basic_istream::sync(), basic_istream::unget(), and std::ws().

  int sync () [inherited]

Synchronizing the stream buffer.

Returns:
    0 on success, -1 on failure

If rdbuf() is a null pointer, returns -1.

Otherwise, calls rdbuf()->pubsync(), and if that returns -1, sets badbit and returns -1.

Otherwise, returns 0.

Note:
    This function does not count the number of characters extracted, if any, and therefore does not affect the next call to gcount().

Definition at line 918 of file istream.tcc.

References basic_ios::_M_setstate(), ios_base::badbit, ios_base::goodbit, basic_streambuf::pubsync(), basic_ios::rdbuf(), and basic_ios::setstate().

  static bool sync_with_stdio (bool __sync = true) [static, inherited]

Interaction with the standard C I/O objects.

Parameters:
    sync Whether to synchronize or not.

Returns:
    True if the standard streams were previously synchronized.

The synchronization referred to is only that between the standard C facilities (e.g., stdout) and the standard C++ objects (e.g., cout). User-declared streams are unaffected. See http://gcc.gnu.org/onlinedocs/libstdc++/27_io/howto.html#8 for more.

  basic_istream< _CharT, _Traits >::pos_type tellg () [inherited]

Getting the current read position.

Returns:
    A file position object.

If fail() is not false, returns pos_type(-1) to indicate failure. Otherwise returns rdbuf()->pubseekoff(0,cur,in).

Note:
    This function does not count the number of characters extracted, if any, and therefore does not affect the next call to gcount().

Definition at line 949 of file istream.tcc.

References basic_ios::_M_setstate(), ios_base::badbit, ios_base::cur, and ios_base::in.

  basic_ostream<_CharT, _Traits>* tie (basic_ostream< _CharT, _Traits > * __tiestr) [inline, inherited]

Ties this stream to an output stream.

Parameters:
    tiestr The output stream.

Returns:
    The previously tied output stream, or NULL if the stream was not tied.

This sets up a new tie; see tie() for more.

Definition at line 293 of file basic_ios.h.

References basic_ios::_M_tie.

  basic_ostream<_CharT, _Traits>* tie () const [inline, inherited]

Fetches the current tied stream.

Returns:
    A pointer to the tied stream, or NULL if the stream is not tied.

A stream may be tied (or synchronized) to a second output stream. When this stream performs any I/O, the tied stream is first flushed. For example, std::cin is tied to std::cout.

Definition at line 281 of file basic_ios.h.

References basic_ios::_M_tie.

Referenced by basic_ios::copyfmt(), basic_ostream::sentry::sentry(), and basic_istream::sentry::sentry().

  basic_istream< _CharT, _Traits > & unget () [inherited]

Unextracting the previous character.

Returns:
    *this

If rdbuf() is not null, calls rdbuf()->sungetc(c).

If rdbuf() is null or if sungetc() fails, sets badbit in the error state.

Note:
    Since no characters are extracted, the next call to gcount() will return 0, as required by DR 60.

Definition at line 890 of file istream.tcc.

References basic_istream::_M_gcount, basic_ios::_M_setstate(), ios_base::badbit, ios_base::goodbit, basic_ios::rdbuf(), basic_ios::setstate(), and basic_streambuf::sungetc().

  void unsetf (fmtflags __mask) [inline, inherited]

Clearing format flags.

Parameters:
    mask The flags to unset.

This function clears mask in the format flags.

Definition at line 606 of file ios_base.h.

References ios_base::_M_flags.

Referenced by std::noboolalpha(), std::noshowbase(), std::noshowpoint(), std::noshowpos(), std::noskipws(), std::nounitbuf(), and std::nouppercase().

  _CharT widen (char __c) const [inherited]

Widens characters.

Parameters:
    c The character to widen.

Returns:
    The widened character.

Maps a character of char to a character of char_type.

Returns the result of

    std::use_facet<ctype<char_type> >(getloc()).widen(c)

Additional l10n notes are at http://gcc.gnu.org/onlinedocs/libstdc++/22_locale/howto.html

Definition at line 121 of file basic_ios.tcc.

References std::__check_facet(), and basic_ios::_M_ctype.

Referenced by std::endl(), basic_ios::fill(), std::getline(), and std::operator>>().

  streamsize width (streamsize __wide) [inline, inherited]

Changing flags.

Parameters:
    wide The new width value.

Returns:
    The previous value of width().

Definition at line 648 of file ios_base.h.

References ios_base::_M_width.

  streamsize width () const [inline, inherited]

Flags access.

Returns:
    The minimum field width to generate on output operations.

Definition at line 640 of file ios_base.h.

References ios_base::_M_width.

Referenced by money_put::_M_insert(), num_put::_M_insert_float(), num_put::_M_insert_int(), basic_ios::copyfmt(), num_put::do_put(), __gnu_cxx::operator<<(), std::operator<<(), and std::operator>>().

  static int xalloc () throw () [static, inherited]

Access to unique indices.

Returns:
    An integer different from all previous calls.

This function returns a unique integer every time it is called. It can be used for any purpose, but is primarily intended to be a unique index for the iword and pword functions. The expectation is that an application calls xalloc in order to obtain an index in the iword and pword arrays that can be used without fear of conflict.

The implementation maintains a static variable that is incremented and returned on each invocation. xalloc is guaranteed to return an index that is safe to use in the iword and pword arrays.

Member Data Documentation

  const fmtflags adjustfield [static, inherited]

A mask of left|right|internal. Useful for the 2-arg form of setf.

Definition at line 308 of file ios_base.h.

Referenced by money_put::_M_insert(), __pad::_S_pad(), std::internal(), std::left(), and std::right().

  const openmode app [static, inherited]

Seek to end before each write.

Definition at line 362 of file ios_base.h.

Referenced by basic_stringbuf::_M_stringbuf_init().

  const openmode ate [static, inherited]

Open and seek to end immediately after opening.

Definition at line 365 of file ios_base.h.

Referenced by basic_stringbuf::_M_stringbuf_init(), and basic_filebuf::open().

  const iostate badbit [static, inherited]

as an irrecoverable read error from a file).

Definition at line 332 of file ios_base.h.

Referenced by basic_ostream::_M_write(), basic_ios::bad(), basic_ios::clear(), basic_ios::fail(), basic_ostream::flush(), basic_istream::get(), std::getline(), basic_istream::getline(), basic_istream::ignore(), basic_ios::init(), std::operator<<(), basic_ostream::operator<<(), basic_istream::operator>>(), std::operator>>(), basic_istream::peek(), basic_ostream::put(), basic_istream::putback(), basic_istream::read(), basic_istream::readsome(), basic_istream::seekg(), basic_ostream::seekp(), basic_istream::sync(), basic_istream::tellg(), basic_ostream::tellp(), basic_istream::unget(), basic_ostream::write(), and basic_ostream::sentry::~sentry().

  const fmtflags basefield [static, inherited]

A mask of dec|oct|hex. Useful for the 2-arg form of setf.

Definition at line 311 of file ios_base.h.

Referenced by std::__int_to_char(), num_get::_M_extract_int(), num_put::_M_insert_int(), std::dec(), num_get::do_get(), num_put::do_put(), std::hex(), std::oct(), basic_ostream::operator<<(), std::operator<<(), and std::operator>>().

  const seekdir beg [static, inherited]

Request a seek relative to the beginning of the stream.

Definition at line 395 of file ios_base.h.

Referenced by stdio_sync_filebuf::seekoff(), stdio_sync_filebuf::seekpos(), and basic_filebuf::seekpos().

  const openmode binary [static, inherited]

http://gcc.gnu.org/onlinedocs/libstdc++/27_io/howto.html#7 for more.

Definition at line 371 of file ios_base.h.

Referenced by basic_filebuf::showmanyc().

  const fmtflags boolalpha [static, inherited]

Insert/extract bool in alphabetic rather than numeric format.

Definition at line 256 of file ios_base.h.

Referenced by std::boolalpha(), num_get::do_get(), num_put::do_put(), and std::noboolalpha().

  const seekdir cur [static, inherited]

Request a seek relative to the current position within the sequence.

Definition at line 398 of file ios_base.h.

Referenced by basic_filebuf::imbue(), basic_filebuf::pbackfail(), stdio_sync_filebuf::seekoff(), basic_stringbuf::seekoff(), basic_filebuf::seekoff(), basic_istream::tellg(), and basic_ostream::tellp().

  const fmtflags dec [static, inherited]

Converts integer input or generates integer output in decimal base.

Definition at line 259 of file ios_base.h.

Referenced by std::dec(), std::operator<<(), and std::operator>>().

  const seekdir end [static, inherited]

Request a seek relative to the current end of the sequence.

Definition at line 401 of file ios_base.h.

Referenced by basic_filebuf::open(), and basic_stringbuf::seekoff().

  const iostate eofbit [static, inherited]

Indicates that an input operation reached the end of an input sequence.

Definition at line 335 of file ios_base.h.

Referenced by money_get::_M_extract(), num_get::_M_extract_float(), num_get::_M_extract_int(), num_get::do_get(), time_get::do_get_date(), time_get::do_get_monthname(), time_get::do_get_time(), time_get::do_get_weekday(), time_get::do_get_year(), basic_ios::eof(), basic_istream::get(), std::getline(), basic_istream::getline(), basic_istream::ignore(), std::operator>>(), basic_istream::peek(), basic_istream::read(), basic_istream::readsome(), basic_istream::sentry::sentry(), and std::ws().

  const iostate failbit [static, inherited]

desired characters.

Definition at line 340 of file ios_base.h.

Referenced by money_get::_M_extract(), num_get::_M_extract_float(), num_get::_M_extract_int(), time_get::_M_extract_name(), time_get::_M_extract_num(), time_get::_M_extract_via_format(), basic_fstream::close(), basic_ofstream::close(), basic_ifstream::close(), num_get::do_get(), time_get::do_get_monthname(), time_get::do_get_weekday(), time_get::do_get_year(), basic_ios::fail(), basic_istream::get(), std::getline(), basic_istream::getline(), basic_fstream::open(), basic_ofstream::open(), basic_ifstream::open(), basic_ostream::operator<<(), basic_istream::operator>>(), std::operator>>(), basic_istream::read(), basic_istream::seekg(), basic_ostream::seekp(), basic_ostream::sentry::sentry(), and basic_istream::sentry::sentry().

  const fmtflags fixed [static, inherited]

Generate floating-point output in fixed-point notation.

Definition at line 262 of file ios_base.h.

Referenced by num_put::_M_insert_float(), and std::fixed().

  const fmtflags floatfield [static, inherited]

A mask of scientific|fixed. Useful for the 2-arg form of setf.

Definition at line 314 of file ios_base.h.

Referenced by std::fixed(), and std::scientific().

  const iostate goodbit [static, inherited]

Indicates all is well.

Definition at line 343 of file ios_base.h.

Referenced by basic_ostream::flush(), basic_istream::get(), std::getline(), basic_istream::getline(), basic_istream::ignore(), basic_ios::init(), basic_ostream::operator<<(), basic_istream::operator>>(), std::operator>>(), basic_istream::peek(), basic_ostream::put(), basic_istream::putback(), basic_istream::read(), basic_istream::readsome(), basic_istream::seekg(), basic_ostream::seekp(), basic_istream::sentry::sentry(), basic_istream::sync(), and basic_istream::unget().

  const fmtflags hex [static, inherited]

Converts integer input or generates integer output in hexadecimal base.

Definition at line 265 of file ios_base.h.

Referenced by std::__int_to_char(), num_get::_M_extract_int(), num_put::_M_insert_int(), num_get::do_get(), num_put::do_put(), std::hex(), basic_ostream::operator<<(), std::operator<<(), and std::operator>>().

  const openmode in [static, inherited]

Open for input. Default for ifstream and fstream.

Definition at line 374 of file ios_base.h.

Referenced by basic_filebuf::_M_set_buffer(), basic_stringbuf::_M_sync(), basic_stringbuf::_M_update_egptr(), basic_ifstream::open(), basic_filebuf::pbackfail(), basic_istream::seekg(), basic_stringbuf::seekoff(), basic_stringbuf::seekpos(), basic_stringbuf::showmanyc(), basic_filebuf::showmanyc(), basic_istream::tellg(), basic_stringbuf::underflow(), basic_filebuf::underflow(), and basic_filebuf::xsgetn().

  const fmtflags internal [static, inherited]

designated.

Definition at line 270 of file ios_base.h.

Referenced by money_put::_M_insert(), __pad::_S_pad(), num_put::do_put(), and std::internal().

  const fmtflags left [static, inherited]

generated output. (I.e., the thing you print is flush left.)

Definition at line 274 of file ios_base.h.

Referenced by money_put::_M_insert(), __pad::_S_pad(), std::left(), and __gnu_cxx::operator<<().

  const fmtflags oct [static, inherited]

Converts integer input or generates integer output in octal base.

Definition at line 277 of file ios_base.h.

Referenced by std::__int_to_char(), num_get::_M_extract_int(), num_put::_M_insert_int(), std::oct(), basic_ostream::operator<<(), std::operator<<(), and std::operator>>().

  const openmode out [static, inherited]

Open for output. Default for ofstream and fstream.

Definition at line 377 of file ios_base.h.

Referenced by basic_filebuf::_M_set_buffer(), basic_stringbuf::_M_sync(), basic_ofstream::open(), basic_stringbuf::overflow(), basic_filebuf::overflow(), basic_stringbuf::pbackfail(), basic_stringbuf::seekoff(), basic_ostream::seekp(), basic_stringbuf::seekpos(), basic_ostream::tellp(), and basic_filebuf::xsputn().

  const fmtflags right [static, inherited]

generated output. (I.e., the thing you print is flush right.)

Definition at line 281 of file ios_base.h.

Referenced by std::right().

  const fmtflags scientific [static, inherited]

Generates floating-point output in scientific notation.

Definition at line 284 of file ios_base.h.

Referenced by std::scientific().

  const fmtflags showbase [static, inherited]

output.

Definition at line 288 of file ios_base.h.

Referenced by money_get::_M_extract(), money_put::_M_insert(), num_put::_M_insert_int(), num_put::do_put(), std::noshowbase(), and std::showbase().

  const fmtflags showpoint [static, inherited]

floating-point output.

Definition at line 292 of file ios_base.h.

Referenced by std::noshowpoint(), and std::showpoint().

  const fmtflags showpos [static, inherited]

Generates a + sign in non-negative generated numeric output.

Definition at line 295 of file ios_base.h.

Referenced by num_put::_M_insert_int(), std::noshowpos(), and std::showpos().

  const fmtflags skipws [static, inherited]

Skips leading white space before certain input operations.

Definition at line 298 of file ios_base.h.

Referenced by std::noskipws(), basic_istream::sentry::sentry(), and std::skipws().

  const openmode trunc [static, inherited]

Open for input. Default for ofstream.

Definition at line 380 of file ios_base.h.

  const fmtflags unitbuf [static, inherited]

Flushes output after each output operation.

Definition at line 301 of file ios_base.h.

Referenced by std::nounitbuf(), std::unitbuf(), and basic_ostream::sentry::~sentry().

  const fmtflags uppercase [static, inherited]

in generated output.

Definition at line 305 of file ios_base.h.

Referenced by std::__int_to_char(), num_put::_M_insert_int(), num_put::do_put(), std::nouppercase(), and std::uppercase().

Author

Generated automatically by Doxygen for libstdc++ from the source code.